#
# spec file for package ofed (Version 1.5.2)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# nodebuginfo


Name:           ofed
Group:          System/Base
Summary:        Infiniband Kernel Modules
Version:        1.5.2
Release:        0.10.30
Source:         ofa_kernel-%{version}.tar.bz2
Source1:        conf.modutils
Source2:        conf.ifcfg
%ifarch ppc ppc64
Source3:        conf.sysconfig.ppc
%else
Source3:        conf.sysconfig
%endif
Source4:        info
Source5:        ofed-docs-%{version}.tar.bz2
Source6:        preamble
Source99:       Module.supported
Patch1:         ofed-1.5.2-ppc-core-return-void.patch
Patch2:         ofed-1.5.2-ppc-sdp-time-h.patch
Patch3:         ofed-1.4.2-openibd-suse-detection.patch
Patch4:         mellanox_ipoib_multicast_fix.patch
Patch5:         ofed-1.3-sp2-netevent-static-link.patch
Patch6:         ofed-1.4.2-fsmode_exec_fix.patch
Patch7:         ofed-1.5.2-openibd-set-node-desc-vul.patch
Patch8:         ofed-1.5.2-check-lap-state.patch
Patch9:         ofed-1.5.2-rds-socket-priv-escalation.patch
Url:            http://www.openfabrics.org
License:        GPL v2 or later
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  kernel-source kernel-syms module-init-tools quilt
PreReq:         %fillup_prereq %insserv_prereq
ExclusiveArch:  %ix86 x86_64 ppc ia64 ppc64
%suse_kernel_module_package -p %_sourcedir/preamble um xen xenpae iseries64

%description
This package contains infiniband kernel modules build from the
OpenFabrics Enterprise Distribution (OFED).



%package devel
License:        GPL v2 or later
Summary:        Infiniband Kernel Modules
Group:          System/Base

%description devel
This package contains infiniband kernel modules build from the
OpenFabrics Enterprise Distribution (OFED).



%package doc
License:        GPL v2 or later
Summary:        OFED documentation
Group:          System/Kernel

%description doc
OpenFabrics documentation



%package KMP
License:        GPL v2 or later
Summary:        Infiniband Kernel Modules
Group:          System/Kernel

%description KMP
This package contains infiniband kernel modules build from the
OpenFabrics Enterprise Distribution (OFED).



%prep
%setup -q -n ofa_kernel-%{version} -a 5

ofed_scripts/ofed_patch.sh --without-quilt --with-backport=2.6.16_sles10_sp3

%patch1 -p1
%patch2 -p1
%patch3 -p1
# Setup SLERT10_SP3
# %patch4 -p1
# Setup SLES10_SP3
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
set -- *
mkdir source
mv "$@" source/
mkdir obj
cp %{S:1} %{S:2} %{S:4} .
cp %{S:3} ./conf.sysconfig
cp %{S:99} source/

%build
%define kver %(echo `rpm -q --queryformat '%{VERSION}-%{RELEASE}' kernel-source`|sed 's/_/-/g;')
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -ar source obj/$flavor
    pushd obj/$flavor
    ./configure --with-core-mod --with-user_mad-mod --with-user_access-mod \
		--with-addr_trans-mod --with-mthca-mod --with-mlx4-mod \
		--with-mlx4_en-mod --with-nes-mod --with-cxgb3-mod \
		--with-ipoib-mod --with-sdp-mod \
		--with-srp-mod --with-srp-target-mod --with-rds-mod \
		--with-ipoib-cm \
		--with-mlx4_core-mod --with-mlx4_inf-mod \
		--with-madeye-mod --with-qlgc_vnic-mod \
		--with-qlgc_vnic_stats-mod \
		$([ "$flavor" != "rt" && "$flavor" != "rt_bigsmp" ] && echo '--with-iser-mod ') \
%ifarch ppc ppc64
		$([ "$flavor" != "default" ] && echo '--with-ehca-mod ') \
%endif
		--kernel-version=%kver-$flavor --kernel-sources=/usr/src/linux-obj/%_target_cpu/$flavor
    make
    popd
done

%install
export NO_BRP_STALE_LINK_ERROR=yes
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
     make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
        M=$PWD/obj/$flavor
     install -d $RPM_BUILD_ROOT/%{_prefix}/src/kernel-modules-ofed/%_target_cpu/$flavor
     sed -n '/infiniband/ { s/\/.*\(drivers\)/\1/;p }' \
        $PWD/obj/$flavor/Modules.symvers > Module.symvers
     install -D Module.symvers \
        $RPM_BUILD_ROOT/%{_prefix}/src/kernel-modules-ofed/%_target_cpu/$flavor/Module.symvers
     rm -f Module.symvers
     ln -s ../../{include,kernel_addons,config.mk} \
          $RPM_BUILD_ROOT/%{_prefix}/src/kernel-modules-ofed/%_target_cpu/$flavor/
done
# cxgb3.ko module are in ofed-cxgb3-NIC package
for file in cxgb3.ko ; do
    find /$RPM_BUILD_ROOT -name $file -exec rm {} \;
done
# install the modutils configuration
install -D conf.modutils ${RPM_BUILD_ROOT}%_sysconfdir/modprobe.d/infiniband
# install the UDEV rules
install -D source/ofed_scripts/90-ib.rules ${RPM_BUILD_ROOT}%_sysconfdir/udev/rules.d/90-ib.rules
# install the ifup network configurations
install -D conf.ifcfg ${RPM_BUILD_ROOT}%_sysconfdir/sysconfig/network/ifcfg-ib0 
install -D conf.ifcfg ${RPM_BUILD_ROOT}%_sysconfdir/sysconfig/network/ifcfg-ib1 
# install the sysconfig file and make a compat link
install -m 700 -D conf.sysconfig ${RPM_BUILD_ROOT}/var/adm/fillup-templates/sysconfig.infiniband
install -d ${RPM_BUILD_ROOT}/%_sysconfdir/infiniband
ln -s %_sysconfdir/sysconfig/infiniband ${RPM_BUILD_ROOT}/%_sysconfdir/infiniband/openib.conf
# install the init script
install -m 755 -D source/ofed_scripts/openibd ${RPM_BUILD_ROOT}%_sysconfdir/init.d/openibd
# install the info script
sed 's/VERSION/%kver/' info > ${RPM_BUILD_ROOT}/%_sysconfdir/infiniband/info
chmod 755 ${RPM_BUILD_ROOT}/%_sysconfdir/infiniband/info
# install the -devel files
# we assume config.mk and the include files are same for all flavors
cp obj/default/config.mk $RPM_BUILD_ROOT/%{_prefix}/src/kernel-modules-ofed/
sed -i -e "s@-I\${CWD}@%{_prefix}/src/kernel-modules-ofed@g" \
	    $RPM_BUILD_ROOT/%{_prefix}/src/kernel-modules-ofed/config.mk
for D in obj/default\\include $(sed 's@^.*-I\${CWD}/@obj/default\\@' obj/default/config.mk); do
    pushd .
    cd ${D/\\*} && find ${D/*\\} -name \*.h -print0  | \
        cpio -0vpd $RPM_BUILD_ROOT/%{_prefix}/src/kernel-modules-ofed/
    popd
done

%clean
rm -rf %buildroot

%post
%{fillup_and_insserv -n -y infiniband openibd}

%postun
%restart_on_update openibd
%insserv_cleanup

%preun
%stop_on_removal openibd

%files
%defattr(-, root, root)
%_sysconfdir/infiniband
%config %_sysconfdir/modprobe.d/infiniband
%_sysconfdir/udev
%config %_sysconfdir/sysconfig/network/ifcfg-ib*
/var/adm/fillup-templates/sysconfig.infiniband
%_sysconfdir/init.d/openibd

%files devel
%defattr(644,root,root,755)
%{_prefix}/src/kernel-modules-ofed

%files doc
%defattr(-, root, root)
%doc source/ofed-docs-%{version}/*

%changelog
* Thu Nov  4 2010 jjolly@novell.com
- VUL-0: rds: ofed-1.5.2-rds-socket-priv-escalation.patch
  (bnc#651061,CVE-2010-3904)
* Thu Oct 28 2010 jjolly@novell.com
- ofed-1.5.2-check-lap-state.patch: rdma/ib_cm: check LAP state
  before sending an MRA (bnc#648019)
* Fri Oct 22 2010 jjolly@novell.com
- ofed-1.5.2-openibd-set-node-desc-vul.patch: Fix scripting
  vulnerability (bnc#648551,CVE-2010-1693)
* Tue Oct 19 2010 jjolly@novell.com
- Updated to v1.5.2, removing many obsolete patches.
* Thu Oct 14 2010 jjolly@novell.com
- Added mlx4_1490 patch backported from OFED 1.5.2 (bnc#642445)
* Wed Oct 13 2010 jjolly@novell.com
- Stepped back to v1.5.1 due to several build problems.
* Mon Oct 11 2010 jjolly@novell.com
- Updated to v1.5.2 and removed unnecessary patches
* Wed Aug 11 2010 dmueller@suse.de
- provide ofed-devel package (bnc#578796)
* Fri Jul  9 2010 sf@suse.de
- add mlx4_core-Allocate-and-map-sufficient-ICM-memory-for-EQ-context.patch
  (bnc #547433)
* Wed Jun  2 2010 Mike Galbraith <mgalbraith@suse.de>
- Modified ofed.spec to copy mellanox_ipoib_multicast_fix.patch to backports.
- cp %%{S:7} kernel_patches/backport/2.6.22_suse10_3/mellanox_ipoib_multicast_fix.patch
* Tue May 18 2010 sf@suse.de
- strip leading directory from last patch (bnc#595820)
* Fri May 14 2010 jjolly@suse.de
- Fixed openibd to check for /etc/SuSE-release (bnc#551897)
* Tue Apr 27 2010 jjolly@novell.com
- Removed iscsi module from rt and rt_bigsmp builds (bnc#551008)
* Wed Mar  3 2010 jjolly@suse.de
- cxgb3: Fixed EEH error on stressed workload (bnc#580054)
* Mon Feb 22 2010 jjolly@suse.de
- Updated to OFED 1.4.2
  - Removed ofed-1.4.1-test_clear_page_dirty.patch
* Fri Aug 21 2009 jjolly@novell.com
- Fix MAC index mapping (bnc#529015)
* Sat Aug  8 2009 jjolly@suse.de
- Added Module.supported to build (bnc#514750)
* Wed Aug  5 2009 jjolly@novell.com
- Added patch to fix cxgb3 Gen2 pci default setting (bnc#497004)
* Tue Aug  4 2009 jjolly@novell.com
- Removed nfsrdma module from build (bnc#527913)
* Wed Jul 29 2009 jjolly@novell.com
- Removed openibd_ud_only patch (bnc#524360)
* Sat Jul 11 2009 jjolly@suse.de
- Added cxgb3_update_2.patch for AEL2020 and AQ100x support
  (bnc#501738)
* Mon Jul  6 2009 jjolly@novell.com
- Changed TestClearPageDirty to test_clear_page_dirty in mm.h
  (bnc#519249,bof#1650)
* Tue Jun 30 2009 hare@suse.de
- Fixup preamble to require the correct kernel flavour (bnc#517388)
* Wed Jun 24 2009 jjolly@novell.com
- Brought back the iw_cxgb3.ko for ofed (bnc#515345)
* Wed Jun 24 2009 jjolly@novell.com
- Added patch for ehca performance impact during creation of queue
  pairs (bnc#515342)
* Wed Jun 24 2009 jjolly@novell.com
- Added ppc to ehca and ipath builds (bnc#515361)
* Mon Jun 15 2009 jjolly@suse.de
- Cleaned up build, added openibd patch
* Fri Jun 12 2009 jjolly@suse.de
- Patch for Enhanced EEH recovery on RNIC (bnc#509403)
* Thu May 28 2009 jjolly@suse.de
- Updated to OFED 1.4.1 GA tarball
- ipath set to build only on 64-bit platforms, except ppc64-default
* Thu May 28 2009 jjolly@suse.de
- Fixed PPC build errors
- Rearranged patches to be more quilt-friendly
- Rather than patch the config, an alternate config has been
  created
* Tue May 26 2009 jjolly@suse.de
- Updated to OFED 1.4.1 rc6
  - Removed many unneeded patches
  - Updated configure command line
  - Removed unholy file list generator, replaced with file wildcard
- Added patch for Chelsio's 10Gb RNIC adapter (bnc#501738)
* Wed Jan  7 2009 jjolly@suse.de
- Changed version to 1.3 to prevent upgrade issues (bnc#435636)
* Thu Dec 11 2008 jjolly@suse.de
- Updated preamble with less specific version check and an
  Enhances line.
* Fri Nov  7 2008 jjolly@suse.de
- Copied two iscsi patches from sles10-sp2 to slert patch directory
* Thu Oct 23 2008 jjolly@suse.de
- Changed int flags to long flags to resolve x86_64 build error
* Wed Oct 15 2008 jjolly@suse.de
- Updated to packages from OFED 1.3.1 release tarball
- Removed several incompatible patches
* Wed Jul 23 2008 jjolly@suse.de
- ehca-04-eoi-on-lost-interrupts.patch: (bnc#403249)
- ehca-05-Filter-PATH_MIG-events-if-QP-was-never-armed.patch:
  (bnc#411261)
- ehca-06-Default-value-for-Local-CA-ACK-Delay.patch: (bnc#411242)
- openibd_ud_only.patch: force set of ud mode on ppc64 (bnc#405013)
* Sat Jun 21 2008 jjolly@suse.de
- Added patch for fixing kernel random panic for noSRQ IPoIB-CM.
  (bnc#400328)
- Added version check on requires in preamble (bnc#395577)
* Thu Jun 12 2008 jjolly@suse.de
- Fixed ipoib skb copy patch (bnc#395582)
* Thu Jun 12 2008 olh@suse.de
- enable build of the QLogic InfiniPath driver for all archs (bnc#395577)
* Thu Jun 12 2008 olh@suse.de
- provide hint to yast for rpm install order (bnc#395577)
* Wed Jun  4 2008 jjolly@suse.de
- Moved ib_core.ko back into package (bnc#395587)
- Added genalloc to iw_cxgb
* Wed May 28 2008 jjolly@suse.de
- Added patch to fix threshold error (bnc#395122)
* Mon May 12 2008 jjolly@suse.de
- Added patch to fix race condition with QP cleanup on multicore
  systems (bnc#388388)
- Removed invalid lines from ehca cq qp control patch (bnc#392183)
* Mon May  5 2008 jjolly@suse.de
- Added patch to fix return type in ehca functions (bnc#378843)
- Renamed ehca patches to induce proper order
* Thu May  1 2008 jjolly@suse.de
- Added patch to fix buffer allocation issue (bnc#385392)
* Wed Apr 30 2008 jjolly@suse.de
- Added patch to allow control of CQ ans QP values (bnc#384433)
* Tue Apr 22 2008 jjolly@suse.de
- Added fix for Mellanox IPoIB Multicast (bnc#281949)
- Added user MAD fix for semaphores (bnc#310587)
* Mon Apr 21 2008 bwalle@suse.de
- fix invalid device properties returned by ehca to run uDAPL
  (bnc#378843)
* Fri Apr 18 2008 bwalle@suse.de
- split ib_core and cxgb3 module to own subpackage (bnc#375152,
  FATE#302603)
* Mon Apr  7 2008 ro@suse.de
- fix build on SLE10-SP2 (remove backport for ip.h)
* Mon Mar 31 2008 jjolly@suse.de
- Added CXGB3_LOAD and MLX4_LOAD to conf.sysconfig (#371873)
* Mon Mar 10 2008 jjolly@suse.de
- Added EHCA_LOAD to conf.sysconfig
- Added ppc-specific patch to enable the ehca module
* Mon Mar  3 2008 jjolly@suse.de
- Patched to build for slert-sp2
- Using scatterlist.h from sles10_sp1 backports
- Using modified netlist.h from sles10_sp1 backports
- Using spin_lock_init instead of assigning SPIN_LOCK_UNLOCKED
* Fri Feb 29 2008 jjolly@suse.de
- Updated to OFED 1.3 GA release
* Thu Feb  7 2008 jjolly@suse.de
- Fixed duplicate definition for __sum16 and WARN_ON_ONCE
* Fri Jan 25 2008 jjolly@suse.de
- Updated to OFED 1.3 rc2 package
* Wed Jan 16 2008 ro@suse.de
- make it build with current SP2 kernel:
  remove local crypto.h include file
* Tue Jan 15 2008 jjolly@suse.de
- Updated to OFED 1.3 version (14 Jan 2008 build)
- Patching to control version for SLES10-SP2
- Patching to fix sk_alloc param change
- Patching to fix cpumask_t include
- Patching to fix param_get_ulong and bool
- Patching to remove dupicate resid functions
* Fri Sep 21 2007 pmullaney@suse.de
- added patch for RT compat semaphore usage in user_mad.c
- patch applied after configure as configure applies ofed patches
* Mon Aug 20 2007 hvogel@suse.de
- Update to OFED 1.2.5 version
- enabled mlx4 module build
- Added ppc64 and ia64 to exclusivearch
- Added %%preun stop_on_removal
* Tue Aug  7 2007 hvogel@suse.de
- Update to OFED 1.2c version
* Fri Aug  3 2007 jblunck@suse.de
- Exclusive build for i386, x86_64 and ppc
* Fri Aug  3 2007 jblunck@suse.de
- Disable KMP for iseries64
* Mon Jul 23 2007 hvogel@suse.de
- Disable VNIC by default
* Fri Jul 20 2007 hvogel@suse.de
- Disable IPATH by default
* Thu Jul 19 2007 hvogel@suse.de
- Fix sysconfig template name
- Enable the the mellanox adapter by default
* Mon Jul 16 2007 hvogel@suse.de
- The doc subpackage is called -doc and not -docs
* Wed Jul 11 2007 hvogel@suse.de
- Rename main package to ofed
- Create ofed-docs as subpackage
- include
  * udev rules
  * ifup infiniband configurations
  * sysconfig file
  * init script
  * info script
  * modutils configuration
* Wed Jul  4 2007 hvogel@suse.de
- Add GPL COPYING file [#289177]
* Fri Jun 22 2007 hvogel@suse.de
- Initial Package, Version 1.2
